/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.net.impl;

import org.xmloperator.lambda.net.model.Walk;
import org.xmloperator.lambda.net.model.WalkStack;
import org.xmloperator.lambda.shared.BaseStack;
import org.xmloperator.lambda.shared.ObjectArrayFactory;

/**
 * WalkStack implementation.
 */
final class WalkStackImpl extends BaseStack implements WalkStack {
	private static final boolean ASSERTION = Test.ASSERTION;
	final OperatorFactoryImpl operatorFactory;

	WalkStackImpl(
		OperatorFactoryImpl operatorFactory,
		ObjectArrayFactory objectArrayFactory) {
		super(objectArrayFactory, false);
		this.operatorFactory = operatorFactory;
	}

	public String toString() {
		if (this.size == 0)
			return "";
		StringBuffer sb = new StringBuffer();
		sb.append('[');
		boolean separate = false;
		for (int k = this.size - 1; k >= 0; k--) {
			if (separate)
				sb.append(' ');
			else
				separate = true;
			sb.append(this.objects[k]);
		}
		sb.append(']');
		return sb.toString();
	}

	///////////////////////////
	// WalkStack implementation
	///////////////////////////

	public void returnToFactory() {
		while (this.size != 0)
			this.pop().returnToFactory();
		this.endUse();
		this.operatorFactory.returnWalkStack(this);
	}

	public void push(Walk walk) {
		this.pushObject(walk);
	}

	public Walk pop() {
		return (Walk) this.popObject();
	}

	public Walk top() {
		return (Walk) this.topObject();
	}

	public Walk getFromTop(int index) {
		return (Walk) this.objects[this.size - 1 - index];
	}

	public void insertFromTop(int index, Walk walk) {
		this.insertObjectFromTop(index, walk);
	}

	public Walk removeFromTop(int index) {
		return (Walk) this.removeObjectFromTop(index);
	}
}
