/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.net.model;

/**
 * Operator with an index.
 * The <tt>Delimiter</tt> and the <tt>Duplicator</tt> are indexed.
 *   The other Operators are not.
 */
public interface IndexedOperator extends Operator {

	/**
	 * Returns the index of this Operator. It is always 0 if the orientation
	 *   is reversed.
	 * @return the index of this Operator.
	 */	
	public int getIndex();
	
	/**
	 * Increment the index of this Operator.
	 * @throws IllegalStateException if the Operator orientation is reversed.
	 */
	public void incrementIndex();
}
