/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.net.model;

/**
 * Walk node. It is used for reading back trees.
 */
public interface Walk {

	/**
	 * Return this to its Factory.
	 * <p><b>Post-condition:</b> this is no more usable.</p>
	 */
	public void returnToFactory();
	
	/**
	 * Returns the bind index of this Walk node.
	 * @return the bind index of this Walk node.
	 */
	public int getBindIndex();

	/**
	 * Adds a director to the director stack.
	 * @param director a director. Values: 1 or 2.
	 * @throws IllegalArgumentException if the given director is neither
	 *   <tt>1</tt> nor <tt>2</tt>.
	 */
	public void pushDirector(int director);

	/**
	 * Pops and returns a director from the director stack.
	 * @return the poped director.
	 * @throws IllegalStateException if the director stack is empty.
	 */	
	public int popDirector();
	
	/**
	 * Returns the WalkStack content of this Walk.
	 * @return the WalkStack content of this Walk.
	 */
	public WalkStack getWalkStack();
}
