/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.net.reduction;

import org.xmloperator.lambda.net.model.Applicator;
import org.xmloperator.lambda.net.model.Eraser;

/**
 * Listener about beta-reduction process.
 */
public interface ReductionListener {

	/**
	 * Notify the starting of a reduction.
	 * May raise a <tt>NotInNormalFormException</tt> in order to stop iterations.
	 * @param rootEraser a root Eraser.
	 * @param redexApplicator the leftermost outermost redex.
	 */
	public void notifyStartReduction(
		Eraser rootEraser,
		Applicator redexApplicator) throws NotInNormalFormException;
}
