/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.translate;

import java.io.PrintStream;

import org.xmloperator.lambda.MainTest;
import org.xmloperator.lambda.net.model.OperatorFactory;
import org.xmloperator.lambda.net.util.InteractionStat;
import org.xmloperator.lambda.tree.model.TermFactory;
import org.xmloperator.lambda.tree.serialize.Serializer;

/**
 * Package test.
 */
public abstract class Test {
	static final boolean ASSERTION = MainTest.ASSERTION;
	static final boolean SCOPE_BINDING = MainTest.SCOPE_BINDING;
	static final TermFactory TERM_FACTORY = MainTest.TERM_FACTORY;
	static final OperatorFactory OPERATOR_FACTORY = MainTest.OPERATOR_FACTORY;
	static final Serializer SERIALIZER = MainTest.SERIALIZER;
	static final InteractionStat INTERACTION_STAT = MainTest.INTERACTION_STAT;
	private static final boolean IS_VERBOSE = false;

	public static void main(String[] args) {
		if (test(System.out, false))
			System.out.println("All is OK");
		System.exit(0);
	}

	/**
	 * Executes some tests on the package.
	 * @param out the PrintStream to print results. May be null.
	 * @param isVerbose if true then all tests have to be displayed.
	 * @return true if all is Ok.
	 */
	public static boolean test(PrintStream out, boolean isVerbose) {
		isVerbose |= IS_VERBOSE;
		boolean isOk = true;
		isOk &= Reducer.test(out, isVerbose);
		isOk &= Generate.test(out, isVerbose);
		return isOk;
	}
}
