/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.tree.impl;

import org.xmloperator.lambda.tree.model.TermWithBody;
import org.xmloperator.lambda.tree.model.Term;
import org.xmloperator.lambda.tree.model.TermFactory;

/**
 * Term implementation.
 */
abstract class TermImpl implements Term {
	final TermFactoryImpl termFactory;
	TermWithBody parent = null;
	boolean isReturnedToTheFactory = false;

	TermImpl(TermFactoryImpl termFactory) {
		this.termFactory = termFactory;
	}

	//////////////////////
	// Term implementation
	//////////////////////

	public TermFactory getFactory() {
		return this.termFactory;
	}

	public boolean canBeReturnedToFactory() {
		return this.parent == null && !this.isReturnedToTheFactory;
	}

	public void returnToFactory() {
		if (!canBeReturnedToFactory())
			throw new IllegalStateException();
		this.isReturnedToTheFactory = true;
	}

	public boolean isLeaf() {
		return false;
	}

	public boolean isEndOfScope() {
		return false;
	}

	public boolean isAbstraction() {
		return false;
	}

	public boolean isApplication() {
		return false;
	}

	public TermWithBody getParent() {
		return this.parent;
	}
}
