/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.tree.impl;

import org.xmloperator.lambda.shared.BaseStack;
import org.xmloperator.lambda.shared.ObjectArrayFactory;
import org.xmloperator.lambda.tree.model.Term;
import org.xmloperator.lambda.tree.model.TermStack;

/**
 * TermStack implementation.
 */
public final class TermStackImpl extends BaseStack implements TermStack {
	final TermFactoryImpl termFactory;

	TermStackImpl(
		TermFactoryImpl termFactory,
		ObjectArrayFactory objectArrayFactory,
		boolean acceptNull) {
		super(objectArrayFactory, acceptNull);
		this.termFactory = termFactory;
	}

	///////////////////////////
	// TermStack implementation
	///////////////////////////

	public void returnToFactory() {
		this.endUse();
		this.termFactory.returnTermStack(this);
	}

	public boolean contains(Term term) {
		return this.containsObject(term);
	}

	public void push(Term term) {
		this.pushObject(term);
	}

	public Term pop() {
		return (Term) this.popObject();
	}

	public Term top() {
		return (Term) this.topObject();
	}
}
