/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.tree.reduction;

import org.xmloperator.lambda.tree.exception.NotInNormalFormException;
import org.xmloperator.lambda.tree.model.Application;
import org.xmloperator.lambda.tree.model.Term;

/**
 * Listener about beta-reduction process.
 */
public interface ReductionListener {
	
	/**
	 * Notify the starting of a reduction.
	 * May raise a <tt>NotInNormalFormException</tt> in order to stop iterations.
	 * @param redex a redex to reduce.
	 */
	public void notifyStartReduction(Application redex) 
	  throws NotInNormalFormException;
	
	/**
	 * Notify the end of a reduction.
	 * @param resultingTerm the Term resulting from the reduction.
	 */
	public void notifyEndReduction(Term resultingTerm);
}
