/**
 * Copyright (c) 2004 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda/).
 */
package org.xmloperator.lambda.tree.util;

import java.io.PrintStream;

import org.xmloperator.lambda.MainTest;
import org.xmloperator.lambda.tree.model.TermFactory;

/**
 * Package test.
 */
public abstract class Test {
	static final boolean ASSERTION = MainTest.ASSERTION;
	static final TermFactory TERM_FACTORY = MainTest.TERM_FACTORY;
	private static final boolean IS_VERBOSE = false;

	public static void main(String[] args) {
		if (test(System.out, false))
			System.out.println("All is OK");
		System.exit(0);
	}

	/**
	 * Executes some tests on the package.
	 * @param out the PrintStream to print results.
	 * @param isVerbose if true then all tests have to be displayed.
	 * @return true if all is Ok.
	 */
	public static boolean test(PrintStream out, boolean isVerbose) {
		isVerbose |= IS_VERBOSE;
		boolean isOk = true;
		isOk &= CommonTerms.test(out, isVerbose);
		isOk &= AlphaUtils.test(out, isVerbose);
		return isOk;
	}
}
